Cell Selection in React Gantt Chart Component

18 Nov 201824 minutes to read

Cell selection in the React Gantt Chart component enables interactive selection of specific cells or ranges of cells within the grid. You may select cells using mouse clicks or arrow keys (up, down, left, right). This is useful for highlighting, manipulating, or performing operations on particular Gantt cells.

Single cell selection

Single cell selection in the Gantt Chart is enabled by setting selectionSettings.mode to Cell and selectionSettings.type to Single. This allows selecting only one cell at a time.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  GanttComponent,
  Inject,
  Selection
} from "@syncfusion/ej2-react-gantt";

import { data } from "./datasource";

function App() {

  const taskSettings = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    endDate: "EndDate",
    duration: "Duration",
    progress: "Progress",
    dependency: "Predecessor",
    parentID: "ParentID"
  };

  const selectionSettings = {
    mode: "Cell",
    type: "Single"
  };

  return (
    <GanttComponent
      height="370px"
      dataSource={data}
      taskFields={taskSettings}
      selectionSettings={selectionSettings}
    >
      <Inject services={[Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById("root"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  GanttComponent,
  Inject,
  Selection
} from "@syncfusion/ej2-react-gantt";

import { data } from "./datasource";

function App() {

  const taskSettings: object = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    endDate: "EndDate",
    duration: "Duration",
    progress: "Progress",
    dependency: "Predecessor",
    parentID: "ParentID"
  };

  const selectionSettings: object = {
    mode: "Cell",
    type: "Single"
  };

  return (
    <GanttComponent
      height="370px"
      dataSource={data}
      taskFields={taskSettings}
      selectionSettings={selectionSettings}
    >
      <Inject services={[Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById("root"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Multiple cell selection

Multiple cell selection in the Gantt Chart is enabled by setting selectionSettings.mode to Cell and selectionSettings.type to Multiple. This allows selecting multiple cells at a time by holding the Ctrl key while clicking on each desired cell.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  GanttComponent,
  Inject,
  Selection
} from "@syncfusion/ej2-react-gantt";

import { data } from "./datasource";

function App() {

  const taskSettings = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    endDate: "EndDate",
    duration: "Duration",
    progress: "Progress",
    dependency: "Predecessor",
    parentID: "ParentID"
  };

  const selectionSettings = {
    mode: "Cell",
    type: "Multiple"
  };

  return (
    <GanttComponent
      height="370px"
      dataSource={data}
      taskFields={taskSettings}
      selectionSettings={selectionSettings}
    >
      <Inject services={[Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById("root"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  GanttComponent,
  Inject,
  Selection,
  TaskFieldsModel,
  SelectionSettingsModel
} from "@syncfusion/ej2-react-gantt";

import { data } from "./datasource";

function App() {

  const taskSettings: TaskFieldsModel = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    endDate: "EndDate",
    duration: "Duration",
    progress: "Progress",
    dependency: "Predecessor",
    parentID: "ParentID"
  };

  const selectionSettings: SelectionSettingsModel = {
    mode: "Cell",
    type: "Multiple"
  };

  return (
    <GanttComponent
      height="370px"
      dataSource={data}
      taskFields={taskSettings}
      selectionSettings={selectionSettings}
    >
      <Inject services={[Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById("root"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Cell selection mode

Cell selection mode controls how cells or ranges are selected. Set the desired mode using selectionSettings.cellSelectionMode:

  • Flow (default): Selects a continuous flow of cells between the start and end indices across rows.
  • Box: Selects a rectangular range covering specified rows and columns.
  • BoxWithBorder: Similar to Box mode, but applies a border for better visual distinction of the selected range.

For cell selection modes, selectionSettings.mode must be Cell or Both, and type must be Multiple.

The following example demonstrates how to change both the selection mode and the cell selection mode using a DropDownList component.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { GanttComponent, Inject, Selection } from "@syncfusion/ej2-react-gantt";
import { DropDownListComponent} from "@syncfusion/ej2-react-dropdowns";
import { data } from "./datasource";

function App() {

    let ganttInstance = null;

    const taskSettings = {
        id: "TaskID",
        name: "TaskName",
        startDate: "StartDate",
        endDate: "EndDate",
        duration: "Duration",
        progress: "Progress",
        parentID: "ParentID"
    };

    const selectionSettings = {
        mode: "Cell",
        type: "Multiple",
        cellSelectionMode: "Flow"
    };

    const modeOptions = [
        { text: "Cell", value: "Cell" },
        { text: "Row", value: "Row" },
        { text: "Both", value: "Both" }
    ];

    const cellModeOptions = [
        { text: "Flow", value: "Flow" },
        { text: "Box", value: "Box" },
        { text: "BoxWithBorder", value: "BoxWithBorder" }
    ];

    function selectionModeChange(args) {
        if (ganttInstance) {
            ganttInstance.treeGrid.grid.selectionSettings.mode = args.value;
            ganttInstance.treeGrid.grid.refresh();
        }
    }

    function cellSelectionModeChange(args) {
        if (ganttInstance) {
            ganttInstance.treeGrid.grid.selectionSettings.cellSelectionMode = args.value;
        }
    }

    return (
        <div>
            <div style=>
                <div>
                    <label style=>Select Mode:</label>
                    <DropDownListComponent
                        width="150"
                        dataSource={modeOptions}
                        index={0}
                        change={selectionModeChange}
                    />
                </div>

                <div>
                    <label style=>Cell Selection Style:</label>
                    <DropDownListComponent
                        width="150"
                        dataSource={cellModeOptions}
                        index={0}
                        change={cellSelectionModeChange}
                    />
                </div>
            </div>

            <GanttComponent
                ref={(g) => (ganttInstance = g)}
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
            >
                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById("root"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { GanttComponent, Inject, Selection, TaskFieldsModel, SelectionSettingsModel } from "@syncfusion/ej2-react-gantt";
import { DropDownListComponent, ChangeEventArgs } from "@syncfusion/ej2-react-dropdowns";
import { data } from "./datasource";

function App() {

    let ganttInstance: GanttComponent | null = null;

    const taskSettings: TaskFieldsModel = {
        id: "TaskID",
        name: "TaskName",
        startDate: "StartDate",
        endDate: "EndDate",
        duration: "Duration",
        progress: "Progress",
        parentID: "ParentID"
    };

    const selectionSettings: SelectionSettingsModel = {
        mode: "Cell",
        type: "Multiple",
        cellSelectionMode: "Flow"
    };

    const modeOptions = [
        { text: "Cell", value: "Cell" },
        { text: "Row", value: "Row" },
        { text: "Both", value: "Both" }
    ];

    const cellModeOptions = [
        { text: "Flow", value: "Flow" },
        { text: "Box", value: "Box" },
        { text: "BoxWithBorder", value: "BoxWithBorder" }
    ];

    function selectionModeChange(args: ChangeEventArgs): void {
        if (ganttInstance) {
            ganttInstance.treeGrid.grid.selectionSettings.mode = args.value as any;
            ganttInstance.treeGrid.grid.refresh();
        }
    }

    function cellSelectionModeChange(args: ChangeEventArgs): void {
        if (ganttInstance) {
            ganttInstance.treeGrid.grid.selectionSettings.cellSelectionMode =
                args.value as any;
        }
    }

    return (
        <div>
            <div style=>
                <div>
                    <label style=>Select Mode:</label>
                    <DropDownListComponent
                        width="150"
                        dataSource={modeOptions}
                        index={0}
                        change={selectionModeChange}
                    />
                </div>

                <div>
                    <label style=>Cell Selection Style:</label>
                    <DropDownListComponent
                        width="150"
                        dataSource={cellModeOptions}
                        index={0}
                        change={cellSelectionModeChange}
                    />
                </div>
            </div>

            <GanttComponent
                ref={(g) => (ganttInstance = g)}
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
            >
                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById("root"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Select cells externally

You may programmatically select a single row, multiple cells, or a range of cells in the Gantt Chart using built-in methods.

Single cell selection

Select a specific cell in the Gantt Chart by calling the selectCell method and providing the desired row and column indexes as arguments.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    GanttComponent,
    Inject,
    Selection
} from "@syncfusion/ej2-react-gantt";

import { TextBoxComponent } from "@syncfusion/ej2-react-inputs";
import { ButtonComponent } from "@syncfusion/ej2-react-buttons";

import { data } from "./datasource";

function App() {

    let ganttInstance = null;
    let rowTextBox = null;
    let cellTextBox = null;

    const taskSettings = {
        id: "TaskID",
        name: "TaskName",
        startDate: "StartDate",
        duration: "Duration",
        progress: "Progress",
        parentID: "ParentID"
    };

    const selectionSettings = {
        mode: "Cell",
        type: "Single"
    };

    function selectCell() {
        const rowIndex = parseInt(rowTextBox.element.value, 10);
        const cellIndex = parseInt(cellTextBox.element.value, 10);

        if (!isNaN(rowIndex) && !isNaN(cellIndex) && ganttInstance) {
            ganttInstance.selectCell({ rowIndex, cellIndex });
        }
    }

    return (
        <div>
            <div style=>
                <label style=>Enter the row index:</label>
                <TextBoxComponent width="100" ref={(t) => (rowTextBox = t)} />

                <label style=>Enter the cell index:</label>
                <TextBoxComponent width="100" ref={(t) => (cellTextBox = t)} />

                <ButtonComponent onClick={selectCell}>Select Cell</ButtonComponent>
            </div>

            <GanttComponent
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
                ref={(g) => (ganttInstance = g)}
            >
                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById("root"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    GanttComponent,
    Inject,
    Selection
} from "@syncfusion/ej2-react-gantt";

import { TextBoxComponent } from "@syncfusion/ej2-react-inputs";
import { ButtonComponent } from "@syncfusion/ej2-react-buttons";

import { data } from "./datasource";

function App() {

    let ganttInstance: GanttComponent | null = null;
    let rowTextBox: TextBoxComponent | null = null;
    let cellTextBox: TextBoxComponent | null = null;

    const taskSettings = {
        id: "TaskID",
        name: "TaskName",
        startDate: "StartDate",
        duration: "Duration",
        progress: "Progress",
        parentID: "ParentID"
    };

    const selectionSettings = {
        mode: "Cell",
        type: "Single"
    };

    function selectCell(): void {
        const rowIndex = parseInt((rowTextBox as any).element.value, 10);
        const cellIndex = parseInt((cellTextBox as any).element.value, 10);

        if (!isNaN(rowIndex) && !isNaN(cellIndex) && ganttInstance) {
            ganttInstance.selectCell({ rowIndex, cellIndex });
        }
    }

    return (
        <div>
            <div style=>
                <label style=>Enter the row index:</label>
                <TextBoxComponent width="100" ref={(t) => (rowTextBox = t)} />

                <label style=>Enter the cell index:</label>
                <TextBoxComponent width="100" ref={(t) => (cellTextBox = t)} />

                <ButtonComponent onClick={selectCell}>Select Cell</ButtonComponent>
            </div>

            <GanttComponent
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
                ref={(g) => (ganttInstance = g)}
            >
                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById("root"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Multiple cell selection

Select multiple cells in the Gantt Chart by calling the selectCells method and providing an array of the row and column indexes for each target cell.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, TaskFieldsModel, SelectionSettingsModel } from '@syncfusion/ej2-react-gantt';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

function App() {
    let ganttInstance;

    const taskFields = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };

    const selectionSettings = {
        mode: 'Cell',
        type: 'Multiple'
    };

    const selectCells = (indexes) => {
        if (ganttInstance) {
            ganttInstance.clearSelection();
            const cell = {
                rowIndex: indexes[0],
                cellIndexes: [indexes[1]]
            };
            console.log('Selected Cell:', cell);
            ganttInstance.selectCells([cell]);
        }
    };

    return (
        <div>
            <div style=>
                <ButtonComponent onClick={() => selectCells([0, 0])}>Select [0, 0]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([1, 1])}>Select [1, 1]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([2, 2])}>Select [2, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([3, 3])}>Select [3, 3]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([4, 4])}>Select [4, 4]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([5, 0])}>Select [5, 0]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([6, 1])}>Select [6, 1]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([7, 2])}>Select [7, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([3, 4])}>Select [3, 4]</ButtonComponent>
            </div>
            <GanttComponent
                height="370px"
                dataSource={data}
                taskFields={taskFields}
                selectionSettings={selectionSettings}
                enableHover={true}
                ref={(gantt: any) => (ganttInstance = gantt)}
            >
                <ColumnsDirective>
                    <ColumnDirective field="TaskID" headerText="ID" width="80" />
                    <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
                    <ColumnDirective field="StartDate" headerText="Start Date" />
                    <ColumnDirective field="Duration" headerText="Duration" />
                    <ColumnDirective field="Progress" headerText="Progress" />
                </ColumnsDirective>
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, TaskFieldsModel, SelectionSettingsModel } from '@syncfusion/ej2-react-gantt';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

function App() {
    let ganttInstance: GanttComponent | null;

    const taskFields: TaskFieldsModel = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };

    const selectionSettings: SelectionSettingsModel = {
        mode: 'Cell',
        type: 'Multiple'
    };

    const selectCells = (indexes: number[]) => {
        if (ganttInstance) {
            ganttInstance.clearSelection();
            const cell = {
                rowIndex: indexes[0],
                cellIndexes: [indexes[1]]
            };
            console.log('Selected Cell:', cell);
            ganttInstance.selectCells([cell]);
        }
    };

    return (
        <div>
            <div style=>
                <ButtonComponent onClick={() => selectCells([0, 0])}>Select [0, 0]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([1, 1])}>Select [1, 1]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([2, 2])}>Select [2, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([3, 3])}>Select [3, 3]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([4, 4])}>Select [4, 4]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([5, 0])}>Select [5, 0]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([6, 1])}>Select [6, 1]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([7, 2])}>Select [7, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectCells([3, 4])}>Select [3, 4]</ButtonComponent>
            </div>
            <GanttComponent
                height="370px"
                dataSource={data}
                taskFields={taskFields}
                selectionSettings={selectionSettings}
                enableHover={true}
                ref={(gantt: any) => (ganttInstance = gantt)}
            >
                <ColumnsDirective>
                    <ColumnDirective field="TaskID" headerText="ID" width="80" />
                    <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
                    <ColumnDirective field="StartDate" headerText="Start Date" />
                    <ColumnDirective field="Duration" headerText="Duration" />
                    <ColumnDirective field="Progress" headerText="Progress" />
                </ColumnsDirective>
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='root'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Get selected cell information

To retrieve information about selected cells in the Gantt Chart, use methods like getSelectedRowCellIndexes method to get the list of row and column indexes for selected cells, and the getCellSelectedRecords method to retrieve the related data objects for each selected cell.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { GanttComponent, Inject, Selection } from "@syncfusion/ej2-react-gantt";
import { ButtonComponent } from "@syncfusion/ej2-react-buttons";
import { DialogComponent } from "@syncfusion/ej2-react-popups";
import { data } from "./datasource";
function App() {

    let ganttObj = null;
    let dialogObj = null;

    function showDetails() {
        if (!ganttObj || !dialogObj) return;

        const selectedRecords = ganttObj.selectionModule.getCellSelectedRecords();
        const selectedIndexes = ganttObj.selectionModule.getSelectedRowCellIndexes();

        const container = document.getElementById("details-container");
        if (!container) return;

        let html = `
            <table border="1" cellpadding="6" cellspacing="0" style="width:100%; border-collapse: collapse;">
                <thead>
                <tr>
                    <th>Row Index</th>
                    <th>Cell Index</th>
                    <th>Row Details</th>
                </tr>
                </thead>
                <tbody>
        `;

        selectedIndexes.forEach((index, i) => {
            const r = selectedRecords[i] || {};

            html += `
            <tr>
            <td>${index.rowIndex}</td>
            <td>${index.cellIndexes.join(", ")}</td>
            <td>
                <table style="width:100%; border-collapse:collapse;">
                <tr><td><b>Task ID:</b></td><td>${r.TaskID}</td></tr>
                <tr><td><b>Task Name:</b></td><td>${r.TaskName}</td></tr>
                <tr><td><b>Start Date:</b></td><td>${r.StartDate ? new Date(r.StartDate).toDateString() : ""}</td></tr>
                <tr><td><b>Duration:</b></td><td>${r.Duration}</td></tr>
                <tr><td><b>Progress:</b></td><td>${r.Progress}%</td></tr>
                </table>
            </td>
            </tr>
        `;
        });

        html += `</tbody></table>`;

        container.innerHTML = html;
        dialogObj.show();
    }

    function closeDialog() {
        dialogObj && dialogObj.hide();
    }

    return (
        <div style=>

            <ButtonComponent onClick={showDetails}>Show Selected Cell Details</ButtonComponent>

            <GanttComponent
                ref={(g) => (ganttObj = g)}
                height="370px"
                dataSource={data}
                selectionSettings=
                taskFields=
            >
                <Inject services={[Selection]} />
            </GanttComponent>

            <DialogComponent
                ref={(d) => (dialogObj = d)}
                header="Selected Cell Details"
                visible={false}
                close={closeDialog}
                width="600px"
                height="300px"
                showCloseIcon={true}
                position=
            >
                <div id="details-container" style=
                ></div>
            </DialogComponent>

        </div>
    );
}

ReactDOM.render(<App />, document.getElementById("root"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { GanttComponent, Inject, Selection } from "@syncfusion/ej2-react-gantt";
import { ButtonComponent } from "@syncfusion/ej2-react-buttons";
import { DialogComponent } from "@syncfusion/ej2-react-popups";
import { data } from "./datasource";
function App() {

    let ganttObj: GanttComponent | null = null;
    let dialogObj: DialogComponent | null = null;

    function showDetails(): void {
        if (!ganttObj || !dialogObj) return;

        const selectedRecords = ganttObj.selectionModule.getCellSelectedRecords();
        const selectedIndexes = ganttObj.selectionModule.getSelectedRowCellIndexes();

        const container = document.getElementById("details-container");
        if (!container) return;

        let html = `
            <table border="1" cellpadding="6" cellspacing="0" style="width:100%; border-collapse: collapse;">
                <thead>
                <tr>
                    <th>Row Index</th>
                    <th>Cell Index</th>
                    <th>Row Details</th>
                </tr>
                </thead>
                <tbody>
        `;

        selectedIndexes.forEach((index: any, i: any) => {
            const r: any = selectedRecords[i] || {};

            html += `
            <tr>
            <td>${index.rowIndex}</td>
            <td>${index.cellIndexes.join(", ")}</td>
            <td>
                <table style="width:100%; border-collapse:collapse;">
                <tr><td><b>Task ID:</b></td><td>${r.TaskID}</td></tr>
                <tr><td><b>Task Name:</b></td><td>${r.TaskName}</td></tr>
                <tr><td><b>Start Date:</b></td><td>${r.StartDate ? new Date(r.StartDate).toDateString() : ""}</td></tr>
                <tr><td><b>Duration:</b></td><td>${r.Duration}</td></tr>
                <tr><td><b>Progress:</b></td><td>${r.Progress}%</td></tr>
                </table>
            </td>
            </tr>
        `;
        });

        html += `</tbody></table>`;

        container.innerHTML = html;
        dialogObj.show();
    }

    function closeDialog(): void {
        dialogObj && dialogObj.hide();
    }

    return (
        <div style=>

            <ButtonComponent onClick={showDetails}>Show Selected Cell Details</ButtonComponent>

            <GanttComponent
                ref={(g) => (ganttObj = g)}
                height="370px"
                dataSource={data}
                selectionSettings=
                taskFields=
            >
                <Inject services={[Selection]} />
            </GanttComponent>

            <DialogComponent
                ref={(d) => (dialogObj = d)}
                header="Selected Cell Details"
                visible={false}
                close={closeDialog}
                width="600px"
                height="300px"
                showCloseIcon={true}
                position=
            >
                <div id="details-container" style=
                ></div>
            </DialogComponent>

        </div>
    );
}

ReactDOM.render(<App />, document.getElementById("root"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Customize cell selection action

You may customize cell selection behavior in the Gantt Chart using cellSelecting, cellSelected, cellDeselecting, and cellDeselected events. These events provide dynamic control over selection, allowing conditional logic and visual updates based on specific criteria.

The following sample demonstrates customizing cell selection in the Gantt Chart using Syncfusion events. In the cellSelected event, the background color is set to rgb(96, 158, 101), while selection is canceled in the cellSelecting event when the TaskName is Perform Soil test. During cellDeselecting, the text color is changed to rgb(253, 253, 253), and in the cellDeselected event, the background color is updated to rgb(245, 69, 69).

import * as React from "react";
import * as ReactDOM from "react-dom";

import {
    GanttComponent,
    Selection,
    Inject
} from "@syncfusion/ej2-react-gantt";


import { data } from "./datasource";

function App() {

    const taskSettings = {
        id: "TaskID",
        name: "TaskName",
        startDate: "StartDate",
        endDate: "EndDate",
        duration: "Duration",
        progress: "Progress",
        parentID: "ParentID"
    };

    const selectionSettings = {
        mode: "Cell",
        type: "Single"
    };

    function updateMessage(text) {
        const msgEl = document.getElementById("message");
        if (msgEl) {
            msgEl.innerText = text;
            msgEl.style.display = "block";
        }
    }

    function cellSelected(args) {
        updateMessage("Trigger cellSelected");
        (args.currentCell).style.backgroundColor = "rgb(96, 158, 101)";
    }

    function cellSelecting(args) {
        updateMessage("Trigger cellSelecting");

        const task = args.data;
        if (task.TaskName === "Perform Soil test") {
            args.cancel = true;
            updateMessage('Trigger cellSelecting - Selection canceled for "Perform Soil test"');
        }
    }

    function cellDeselected(args) {
        updateMessage("Trigger cellDeselected");

        if (args.cells && args.cells.length > 0) {
            const cell = args.cells[0];
            cell.style.backgroundColor = "rgb(245, 69, 69)";
        }
    }

    function cellDeselecting(args) {
        updateMessage("Trigger cellDeselecting");

        if (args.cells && args.cells.length > 0) {
            const cell = args.cells[0];
            cell.style.color = "rgb(253, 253, 253)";
        }
    }

    return (
        <div>
            <p id="message" style=></p>
            <GanttComponent
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
                enableHover={false}
                cellSelected={cellSelected}
                cellSelecting={cellSelecting}
                cellDeselected={cellDeselected}
                cellDeselecting={cellDeselecting}
            >
                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById("root"));
import * as React from "react";
import * as ReactDOM from "react-dom";

import {
    GanttComponent,
    Selection,
    Inject
} from "@syncfusion/ej2-react-gantt";

import { CellSelectingEventArgs, CellSelectEventArgs, CellDeselectEventArgs } from "@syncfusion/ej2-react-grids";

import { data } from "./datasource";

function App() {

    const taskSettings: object = {
        id: "TaskID",
        name: "TaskName",
        startDate: "StartDate",
        endDate: "EndDate",
        duration: "Duration",
        progress: "Progress",
        parentID: "ParentID"
    };

    const selectionSettings: object = {
        mode: "Cell",
        type: "Single"
    };

    function updateMessage(text: string): void {
        const msgEl = document.getElementById("message");
        if (msgEl) {
            msgEl.innerText = text;
            msgEl.style.display = "block";
        }
    }

    function cellSelected(args: CellSelectEventArgs): void {
        updateMessage("Trigger cellSelected");
        (args.currentCell as HTMLElement).style.backgroundColor = "rgb(96, 158, 101)";
    }

    function cellSelecting(args: CellSelectingEventArgs): void {
        updateMessage("Trigger cellSelecting");

        const task: any = args.data;
        if (task.TaskName === "Perform Soil test") {
            args.cancel = true;
            updateMessage('Trigger cellSelecting - Selection canceled for "Perform Soil test"');
        }
    }

    function cellDeselected(args: CellDeselectEventArgs): void {
        updateMessage("Trigger cellDeselected");

        if (args.cells && args.cells.length > 0) {
            const cell = args.cells[0] as HTMLElement;
            cell.style.backgroundColor = "rgb(245, 69, 69)";
        }
    }

    function cellDeselecting(args: CellDeselectEventArgs): void {
        updateMessage("Trigger cellDeselecting");

        if (args.cells && args.cells.length > 0) {
            const cell = args.cells[0] as HTMLElement;
            cell.style.color = "rgb(253, 253, 253)";
        }
    }

    return (
        <div>
            <p id="message" style=></p>
            <GanttComponent
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
                enableHover={false}
                cellSelected={cellSelected}
                cellSelecting={cellSelecting}
                cellDeselected={cellDeselected}
                cellDeselecting={cellDeselecting}
            >
                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById("root"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Limitations for cell selection

  • Cell-based selection is not supported when virtualization is enabled.

Cell Selection in Angular Gantt Chart Component

18 Nov 201824 minutes to read

Cell selection in the Gantt Chart component enables interactive selection of specific cells or ranges of cells within the grid. You may select cells using mouse clicks or arrow keys (up, down, left, right). This is useful for highlighting, manipulating, or performing operations on particular Gantt cells.

Single cell selection

Single cell selection in the Gantt Chart is enabled by setting selectionSettings.mode to Cell and selectionSettings.type to Single. This allows selecting only one cell at a time.

import { Component, OnInit, ViewEncapsulation } from '@angular/core';
import { GanttModule, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';

@Component({
  standalone: true,
  selector: 'app-root',
  imports: [GanttModule],
  providers: [SelectionService],
  template: `
    <ejs-gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings">
    </ejs-gantt>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};

  ngOnInit(): void {
    this.data = [
      {
        TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      {
        TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      endDate: 'EndDate',
      duration: 'Duration',
      progress: 'Progress',
      dependency: 'Predecessor',
      parentID: 'ParentID'
    };
    this.selectionSettings = {
      mode: 'Cell',
      type: 'Single'
    };
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Multiple cell selection

Multiple cell selection in the Gantt Chart is enabled by setting selectionSettings.mode to Cell and selectionSettings.type to Multiple. This allows selecting multiple cells at a time by holding the Ctrl key while clicking on each desired cell.

import { Component, OnInit, ViewEncapsulation } from '@angular/core';
import { GanttModule, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';

@Component({
  standalone: true,
  selector: 'app-root',
  imports: [GanttModule],
  providers: [SelectionService],
  template: `
    <ejs-gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings">
    </ejs-gantt>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};

  ngOnInit(): void {
    this.data = [
      {
        TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      {
        TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      endDate: 'EndDate',
      duration: 'Duration',
      progress: 'Progress',
      dependency: 'Predecessor',
      parentID: 'ParentID'
    };
    this.selectionSettings = {
      mode: 'Cell',
      type: 'Multiple'
    };
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Cell selection mode

Cell selection mode controls how cells or ranges are selected. Set the desired mode using selectionSettings.cellSelectionMode:

  • Flow (default): Selects a continuous flow of cells between the start and end indices across rows.
  • Box: Selects a rectangular range covering specified rows and columns.
  • BoxWithBorder: Similar to Box mode, but applies a border for better visual distinction of the selected range.

For cell selection modes, selectionSettings.mode must be Cell or Both, and type must be Multiple.

You can dynamically update cellSelectionMode with a DropDownList component, as shown in this example:

import { Component, OnInit, ViewChild } from '@angular/core';
import { GanttComponent, GanttModule, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { DropDownListModule } from '@syncfusion/ej2-angular-dropdowns';
import { ChangeEventArgs } from '@syncfusion/ej2-dropdowns';
import { SelectionSettingsModel, CellSelectionMode } from '@syncfusion/ej2-angular-grids';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttModule, DropDownListModule],
  providers: [SelectionService],
  template: `
    <div style="display: flex">
      <label style="padding: 30px 17px 0 0">Choose cell selection mode:</label>
      <ejs-dropdownlist style="padding: 26px 0 0 0" index="0" width="150"
        [dataSource]="dropdownData" (change)="valueChange($event)">
      </ejs-dropdownlist>
    </div>
    <div style="padding: 20px 0px 0px 0px">
      <ejs-gantt #gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings">
      </ejs-gantt>
    </div>
  `
})
export class AppComponent implements OnInit {

  @ViewChild('gantt') public gantt?: GanttComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};
  public dropdownData: Object[] = [
    { text: 'Flow', value: 'Flow' },
    { text: 'Box', value: 'Box' },
    { text: 'BoxWithBorder', value: 'BoxWithBorder' }
  ];
  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.selectionSettings = { mode: 'Cell', type: 'Multiple' };
  }
  valueChange(args: ChangeEventArgs): void {
    if (this.gantt) {
      this.gantt.treeGrid.grid.selectionSettings.cellSelectionMode = args.value as CellSelectionMode;
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Select cells externally

You may programmatically select a single row, multiple cells, or a range of cells in the Gantt Chart using built-in methods.

Single cell selection

Select a specific cell in the Gantt Chart by calling the selectCell method and providing the desired row and column indexes as arguments.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { GanttComponent, GanttModule, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';
import { TextBoxComponent, TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
  standalone: true,
  selector: 'app-root',
  imports: [GanttModule, TextBoxModule, ButtonModule],
  providers: [SelectionService],
  template: `  
        <div style="display: flex; align-items: center; gap: 10px; margin-bottom: 10px;">
            <label style="font-weight: bold;">Enter the row index:</label>
            <ejs-textbox #rowtextbox width="100"></ejs-textbox>
            <label style="font-weight: bold;">Enter the cell index:</label>
            <ejs-textbox #celltextbox width="100"></ejs-textbox>
            <button ejs-button (click)="click()">Select Cell</button>
        </div>
        <ejs-gantt #gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings">
        </ejs-gantt>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
  @ViewChild('gantt', { static: true }) public ganttInstance!: GanttComponent;
  @ViewChild('rowtextbox', { static: false }) public rowtextbox?: TextBoxComponent;
  @ViewChild('celltextbox', { static: false }) public celltextbox?: TextBoxComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Initiation Phase', StartDate: new Date('2023-04-01'), Duration: 5, Progress: 40 },
      { TaskID: 2, TaskName: 'Site Survey', StartDate: new Date('2023-04-06'), Duration: 4, ParentID: 1, Progress: 60 },
      { TaskID: 3, TaskName: 'Soil Testing', StartDate: new Date('2023-04-10'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Approval Process', StartDate: new Date('2023-04-14'), Duration: 3, ParentID: 1, Progress: 30 },
      { TaskID: 5, TaskName: 'Estimation Phase', StartDate: new Date('2023-04-18'), Duration: 6, Progress: 20 },
      { TaskID: 6, TaskName: 'Floor Plan Design', StartDate: new Date('2023-04-24'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'Material Listing', StartDate: new Date('2023-04-27'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Final Approval', StartDate: new Date('2023-04-30'), Duration: 2, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.selectionSettings = {
      mode: 'Cell',
      type: 'Single'
    };
  }

  public click(): void {
    const rowIndexValue = (this.rowtextbox as TextBoxComponent).element.value as string;
    const cellIndexValue = (this.celltextbox as TextBoxComponent).element.value as string;
    const rowIndex = parseInt(rowIndexValue, 10);
    const cellIndex = parseInt(cellIndexValue, 10);
    if (!isNaN(cellIndex)) {
      this.ganttInstance.selectCell({
        rowIndex: rowIndex,
        cellIndex: cellIndex
      });
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Multiple cell selection

Select multiple cells in the Gantt Chart by calling the selectCells method and providing an array of the row and column indexes for each target cell.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { GanttComponent, GanttModule, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
  standalone: true,
  selector: 'app-root',
  imports: [GanttModule, ButtonModule],
  providers: [SelectionService],
  template: `
  <div style="display: flex; flex-wrap: wrap; gap: 10px; padding: 10px 0 20px 0;">
    <button ejs-button (click)="selectCells([0, 0])">Select [0, 0]</button>
    <button ejs-button (click)="selectCells([1, 1])">Select [1, 1]</button>
    <button ejs-button (click)="selectCells([2, 2])">Select [2, 2]</button>
    <button ejs-button (click)="selectCells([3, 3])">Select [3, 3]</button>
    <button ejs-button (click)="selectCells([4, 4])">Select [4, 4]</button>
    <button ejs-button (click)="selectCells([5, 0])">Select [5, 0]</button>
    <button ejs-button (click)="selectCells([6, 1])">Select [6, 1]</button>
    <button ejs-button (click)="selectCells([7, 2])">Select [7, 2]</button>
    <button ejs-button (click)="selectCells([3, 4])">Select [3, 4]</button>
  </div>
  <ejs-gantt #gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings" enableHover="true">
  </ejs-gantt>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
  @ViewChild('gantt', { static: true }) public ganttInstance!: GanttComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Kickoff', StartDate: new Date('2023-04-01'), Duration: 5, Progress: 40 },
      { TaskID: 2, TaskName: 'Requirement Gathering', StartDate: new Date('2023-04-06'), Duration: 4, ParentID: 1, Progress: 60 },
      { TaskID: 3, TaskName: 'Feasibility Study', StartDate: new Date('2023-04-10'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Initial Approval', StartDate: new Date('2023-04-14'), Duration: 3, ParentID: 1, Progress: 30 },
      { TaskID: 5, TaskName: 'Design Phase', StartDate: new Date('2023-04-18'), Duration: 6, Progress: 20 },
      { TaskID: 6, TaskName: 'UI/UX Design', StartDate: new Date('2023-04-24'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'Architecture Planning', StartDate: new Date('2023-04-27'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Final Review', StartDate: new Date('2023-04-30'), Duration: 2, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.selectionSettings = {
      mode: 'Cell',
      type: 'Multiple'
    };
  }
  public selectCells(indexes: number[]): void {
    (this.ganttInstance as GanttComponent).clearSelection();
    const rowIndex = indexes[0];
    const cellIndex = indexes[1];
    const cell = {
      rowIndex: rowIndex,
      cellIndexes: [cellIndex]
    };
    (this.ganttInstance as GanttComponent).selectCells([cell]);
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Get selected cell information

To retrieve information about selected cells in the Gantt Chart, use methods like getSelectedRowCellIndexes method to get the list of row and column indexes for selected cells, and the getCellSelectedRecords method to retrieve the related data objects for each selected cell.

import { Component, ViewChild, OnInit, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { GanttComponent, GanttModule, SelectionService, SelectionSettingsModel } from '@syncfusion/ej2-angular-gantt';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { DialogModule } from '@syncfusion/ej2-angular-popups';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, GanttModule, ButtonModule, DialogModule],
  providers: [SelectionService],
  encapsulation: ViewEncapsulation.None,
  template: `
    <div style="padding: 10px 0px 20px 0px">
      <button ejs-button class="btn" (click)="showSelectedDetails()">Show Selected Cell Details</button>
    </div>
    <ejs-gantt #gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings"> 
    </ejs-gantt>
    <ejs-dialog [header]="'Selected Cell Details'" [visible]="dialogVisible" (close)="dialogClose()" showCloseIcon="true" width="600px" height="300px" [position]="{ X: 300, Y: 100 }">
      <ng-template #content>
        <div style="max-height: 240px; overflow-y: auto; padding-right: 10px;">
          <table border="1" cellpadding="5" cellspacing="0" style="width: 100%;">
            <thead>
              <tr>
                <th>Row Index</th>
                <th>Cell Index</th>
                <th>Row Details</th>
              </tr>
            </thead>
            <tbody>
              <tr *ngFor="let detail of selectedDetails">
                <td></td>
                <td></td>
                <td>
                  <table style="width: 100%; border-collapse: collapse;">
                    <tr>
                      <td><strong>Task ID:</strong></td>
                      <td></td>
                    </tr>
                    <tr>
                      <td><strong>Task Name:</strong></td>
                      <td></td>
                    </tr>
                    <tr>
                      <td><strong>Start Date:</strong></td>
                      <td></td>
                    </tr>
                    <tr>
                      <td><strong>Duration:</strong></td>
                      <td></td>
                    </tr>
                    <tr>
                      <td><strong>Progress:</strong></td>
                      <td>%</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </ng-template>
    </ejs-dialog>`
})

export class AppComponent implements OnInit {
  @ViewChild('gantt', { static: true }) public ganttInstance!: GanttComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {
    mode: 'Cell',
    type: 'Multiple'
  };
  public selectedDetails: {
    rowIndex: number;
    cellIndex: string;
    record: GanttTask;
  }[] = [];

  public dialogVisible: boolean = false;

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 80 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];

    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      endDate: 'EndDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
  }

  public showSelectedDetails(): void {
    const records = this.ganttInstance.selectionModule.getCellSelectedRecords() as GanttTask[];
    const indexes = this.ganttInstance.selectionModule.getSelectedRowCellIndexes();

    this.selectedDetails = indexes.map((index, i) => ({
      rowIndex: index.rowIndex,
      cellIndex: index.cellIndexes.join(', '),
      record: records[i] || {}
    }));

    this.dialogVisible = true;
  }

  public dialogClose(): void {
    this.dialogVisible = false;
  }
}

interface GanttTask {
  TaskID: number;
  TaskName: string;
  StartDate: Date;
  EndDate?: Date;
  Duration?: number;
  Progress?: number;
  ParentID?: number;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customize cell selection action

You may customize cell selection behavior in the Gantt Chart using cellSelecting, cellSelected, cellDeselecting, and cellDeselected events. These events provide dynamic control over selection, allowing conditional logic and visual updates based on specific criteria.

The following sample demonstrates customizing cell selection in the Gantt Chart using Syncfusion events. In the cellSelected event, the background color is set to rgb(96, 158, 101), while selection is canceled in the cellSelecting event when the TaskName is Perform Soil test. During cellDeselecting, the text color is changed to rgb(253, 253, 253), and in the cellDeselected event, the background color is updated to rgb(245, 69, 69).

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { GanttComponent, GanttModule, CellSelectingEventArgs, SelectionService, SelectionSettingsModel } from '@syncfusion/ej2-angular-gantt';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { CellSelectEventArgs, CellDeselectEventArgs } from '@syncfusion/ej2-angular-grids';

interface Task {
  TaskID: number;
  TaskName: string;
  StartDate: Date;
  EndDate?: Date;
  Duration?: number;
  Progress?: number;
  ParentID?: number;
}

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, GanttModule, ButtonModule],
  providers: [SelectionService],
  encapsulation: ViewEncapsulation.None,
  template: `
    <p id="message" *ngIf="showMessage"></p>
    <ejs-gantt #gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" (cellSelected)="cellSelected($event)" (cellSelecting)="cellSelecting($event)" (cellDeselected)="cellDeselected($event)" (cellDeselecting)="cellDeselecting($event)" [selectionSettings]="selectionSettings" enableHover="false">
    </ejs-gantt>`
})

export class AppComponent implements OnInit {
  @ViewChild('gantt', { static: true }) public ganttInstance!: GanttComponent;
  public data: Task[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};
  public showMessage = false;
  public message = '';

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 60 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 30 },
      { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 90 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 30 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 80 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      endDate: 'EndDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.selectionSettings = {
      mode: 'Cell',
      type: 'Single'
    };
  }

  public cellSelected(args: CellSelectEventArgs): void {
    this.message = `Trigger cellSelected`;
    this.showMessage = true;
    (args.currentCell as HTMLElement).style.backgroundColor = 'rgb(96, 158, 101)';
  }

  public cellSelecting(args: CellSelectingEventArgs): void {
    this.message = `Trigger cellSelecting`;
    this.showMessage = true;
    const task = args.data as Task;
    if (task.TaskName === 'Perform Soil test') {
      args.cancel = true;
      this.message += ' - Selection canceled for "Perform Soil test"';
    }
  }

  public cellDeselected(args: CellDeselectEventArgs): void {
    this.message = `Trigger cellDeselected`;
    this.showMessage = true;
    if (args.cells && args.cells.length > 0) {
      const cell = args.cells[0] as HTMLElement;
      cell.style.backgroundColor = 'rgb(245, 69, 69)';
    }
  }

  public cellDeselecting(args: CellDeselectEventArgs): void {
    this.message = `Trigger cellDeselecting`;
    this.showMessage = true;
    if (args.cells && args.cells.length > 0) {
      const cell = args.cells[0] as HTMLElement;
      cell.style.color = 'rgb(253, 253, 253)';
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Limitations for cell selection

  • Cell-based selection is not supported when virtualization is enabled.

Cell Selection in Vue Gantt Chart Component

18 Nov 201824 minutes to read

You can select a cell in the Gantt Chart component by setting the https://ej2.syncfusion.com/vue/documentation/api/gantt/selectionSettings#mode property to cell. You can get the selected cell information using the https://ej2.syncfusion.com/vue/documentation/api/gantt/selection#getselectedrowcellindexes method. This method returns the result as an object collection, which contains the cellIndexes and rowIndex information of the selected cells.

Refer to the following code example to enable cell selection in Gantt.

<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { GanttComponent as EjsGantt, Selection } from "@syncfusion/ej2-vue-gantt";
const data = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
const selectionSettings = {
    mode: 'Cell'
}
provide('gantt',  [ Selection ]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Selection } from "@syncfusion/ej2-vue-gantt";
export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ],
            height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            },
            selectionSettings: {
                mode: 'Cell'
            }
      };
  },
  provide: {
      gantt: [ Selection ]
  }
};
</script>

Selecting multiple cells

You can select multiple cells by setting the https://ej2.syncfusion.com/vue/documentation/api/gantt/selectionSettings#type property to multiple and the https://ej2.syncfusion.com/vue/documentation/api/gantt/selectionSettings#mode property to cell. Multiple cells can be selected by holding the CTRL key and selecting the cells. The following code example demonstrates how to select multiple cells.

<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { GanttComponent as EjsGantt, Selection } from "@syncfusion/ej2-vue-gantt";
const data = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
const selectionSettings = {
    mode: 'Cell'
}
provide('gantt',  [ Selection ]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Selection } from "@syncfusion/ej2-vue-gantt";

export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ],
            height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            },
            selectionSettings: {
                mode: 'Cell',
                type: 'Multiple'
            }
      };
  },
  provide: {
      gantt: [ Selection ]
  }
};
</script>

Selecting a cell dynamically

You can select a cell dynamically using the https://ej2.syncfusion.com/vue/documentation/api/gantt/selection#selectcell method. Refer to the following code example for details.

<template>
     <div>
        <ejs-button id="selectCell" cssClass="e-info" v-on:click="select">Select Cell</ejs-button>
        <br>
        <br>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height ="height" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { GanttComponent as EjsGantt, Selection } from "@syncfusion/ej2-vue-gantt";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";

const gantt = ref(null);
const data = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
const selectionSettings = {
    mode: 'Cell'
}
const select = function(e){
    var ganttObj = gantt.value.ej2Instances;
    ganttObj.selectionModule.selectCell({ cellIndex: 1, rowIndex: 1 });
}
provide('gantt',  [ Selection ]);
</script>
<template>
     <div>
        <ejs-button id="selectCell" cssClass="e-info" v-on:click="select">Select Cell</ejs-button>
        <br>
        <br>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height ="height" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Selection } from "@syncfusion/ej2-vue-gantt";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";
export default {
name: "App",
components: {
"ejs-button":ButtonComponent,
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ],
            height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            },
            selectionSettings: {
                mode: 'Cell'
            }
      };
  },
  provide: {
      gantt: [ Selection ]
  },
  methods: {
      select: function(e){
          var ganttObj = document.getElementById('GanttContainer').ej2_instances[0];
          ganttObj.selectionModule.selectCell({ cellIndex: 1, rowIndex: 1 });
      },
  }
};
</script>

Customize cell selection action

While selecting a cell in Gantt, the https://ej2.syncfusion.com/vue/documentation/api/gantt#cellselecting and https://ej2.syncfusion.com/vue/documentation/api/gantt#cellselected events will be triggered. The cellSelecting event will be triggered at the initialization of the cell selection action, and you can get the currently selecting cell information to prevent the selection of a particular cell in a particular row. The cellSelected event will be triggered upon completion of the cell selection action, and you can get the currently selected cell’s information. The following code example demonstrates how to prevent the selection of a cell using the cellSelecting event.

<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :cellSelecting="cellSelecting" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { GanttComponent as EjsGantt, Selection } from "@syncfusion/ej2-vue-gantt";
const data = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
const cellSelecting = function (args) {
    if (args.data.TaskID == 4 && args.cellIndex.cellIndex == 1) {
        args.cancel = true;
    }
};
const selectionSettings = {
    mode: 'Cell'
}
provide('gantt',  [ Selection ]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :cellSelecting="cellSelecting" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Selection } from "@syncfusion/ej2-vue-gantt";

export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ],
            height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            },
            cellSelecting: function (args) {
                if (args.data.TaskID == 4 && args.cellIndex.cellIndex == 1) {
                    args.cancel = true;
                }
            },
            selectionSettings: {
                mode: 'Cell'
            }
      };
  },
  provide: {
      gantt: [ Selection ]
  }
};
</script>

Limitations for cell selection

  • Cell-based selection is not supported when virtualization is enabled.